!  Thu Oct 22 15:03:47 CEST 2015
!  Written by Pedro Ojeda
      PROGRAM HELLO
      USE OMP_LIB
      IMPLICIT NONE
      INTEGER :: I
      INTEGER, PARAMETER :: NLIN=10000000
      INTEGER  :: T1,T2,rate,n
      REAL*8  :: X,X_TEMP

!Sum the first NLIN integers serial program
      n=nlin
      CALL SYSTEM_CLOCK(COUNT_RATE=RATE)
      CALL SYSTEM_CLOCK(T1)
      X=0.0D0
      DO I=1,NLIN
      X= X + I*1.0
      ENDDO
      CALL SYSTEM_CLOCK(T2)

      WRITE(*,*) 'SUM=', X, 'TIME', T2-T1

!Sum the first NLIN integers using OpenMP ATOMIC directive
      CALL SYSTEM_CLOCK(T1)
      X=0.0D0
!$OMP PARALLEL DO
      DO I=1,NLIN
      !$OMP ATOMIC
      X= X + I*1.0
      ENDDO
!$OMP END PARALLEL DO
      CALL SYSTEM_CLOCK(T2)

      WRITE(*,*) 'SUM=', X, 'TIME', T2-T1

!Sum the first NLIN integers using OpenMP REDUCTION directive
      CALL SYSTEM_CLOCK(T1)
      X=0.0D0
!$OMP PARALLEL DO reduction(+:x)
      DO I=1,NLIN
      X= X + I*1.0
      ENDDO
!$OMP END PARALLEL DO
      CALL SYSTEM_CLOCK(T2)

      WRITE(*,*) 'SUM=', X, 'TIME', T2-T1


      END
